/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.staat;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.staat.boundary.AbstractStaatenGruppeSearchParameters;
import de.ivu.elect.business.staat.boundary.StaatenGruppeChangeEvent;
import de.ivu.elect.business.staat.boundary.StaatenGruppeConversationStore;
import de.ivu.elect.business.staat.boundary.StaatenGruppeExtendedDAO;
import de.ivu.elect.business.staat.boundary.StaatenGruppeSearch;
import de.ivu.elect.business.staat.boundary.StaatenGruppeSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.staat.entity.StaatenGruppe;
import de.ivu.elect.business.staat.entity.StaatenGruppeMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStaatenGruppeSearchView.COMPONENT_NAME)
@View(viewId = AbstractStaatenGruppeSearchView.VIEW_ID, useCase = UseCasePermission.STAATEN_GRUPPE_SEARCH)
public abstract class AbstractStaatenGruppeSearchView extends AbstractElectSearchView<StaatenGruppe> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatenGruppeSearchView";
  
  public static final String VIEW_ID = "/staat/staaten-gruppe-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStaatenGruppeSearchView requestHandler;

  @Inject
  private transient StaatenGruppeExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StaatenGruppeConversationStore.class)
  protected transient StaatenGruppeConversationStore conversationStore;

  @Inject
  protected transient StaatenGruppeSearch search;

  @Inject
  @ConversationGroup(AbstractStaatenGruppeSearchParameters.class)
  protected transient StaatenGruppeSearchParameters searchParameters;

  @Inject
  protected transient StaatenGruppeMeta entityMeta;

  public AbstractStaatenGruppeSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public StaatenGruppe getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(StaatenGruppe entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StaatenGruppeSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<StaatenGruppe> getEagerLoadingCollector() {
    return EagerLoadingCollector.<StaatenGruppe> create();
  }

  @Override
  public List<StaatenGruppe> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<StaatenGruppe> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStaatenGruppeChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StaatenGruppeChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStaatenGruppeSearchView {

    @View
    @Inject
    private transient Instance<AbstractStaatenGruppeSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStaatenGruppeSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
